/*
 * Aimject
 *
 * Copyright (C) 2006 Jon Oberheide <jon@oberheide.org>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef AIM_H
#define AIM_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <dnet.h>
#include <config.h>

#include "main.h"
#include "conn.h"

#define MAX_SN_LEN		16

#define FLAP_CMD_START		0x2a
#define FLAP_FNAC_DATA		0x02

#define FNAC_FAM_SIGNON		0x0017
#define FNAC_SUB_LOGONREPLY	0x0003

#define FNAC_FAM_MESSAGE	0x0004
#define FNAC_SUB_INCOMING	0x0007
#define FNAC_SUB_OUTGOING	0x0006

#define TLV_TYPE_LEN		2
#define TLV_LENGTH_LEN		2

#define TLV_BOS			0x0005
#define TLV_SCREENNAME		0x0001

#define TLV_AUTO_RESP		0x0004

#define TLV_MESSAGE		0x0002
#define TLV_MESSAGE_BLOCK	0x0101
#define TLV_MESSAGE_LEN		16

#define TLV_FEATURES		0x0501
#define TLV_FEATURES_LEN	4
#define TLV_FEATURES_VAL	0x01010102

#define FLAP_LEN		6
#define FNAC_LEN		10
#define ICBM_COOKIE_LEN		8

#define MSG_CHANNEL_ID		0x0001
#define MSG_CHANNEL_ID_LEN	2

enum {
	MSG_NONE = 0,
	MSG_AUTO_RESP,
	MSG_INJECT,
	MSG_MUTED
};

typedef struct {
	guint8 cmd;
	guint8 channel;
	guint16 seqnum;
	guint16 length;
	gchar *ptr;
} flap_t;

typedef struct {
	guint16 family;
	guint16 subtype;
	guint16 flags;
	guint32 id;
	gchar *ptr;
} fnac_t;

typedef struct {
	guint16 type;
	guint16 length;
	gchar *value;
	gchar *ptr;
} tlv_t;

gint dissect_aim_bos(client_t *client, gchar *buf, gint buf_len);
gboolean dissect_aim_msg(client_t *client, gchar *buf, gint buf_len, gint direction);
gboolean inject_aim_msg(client_t *client, conv_t *conv, gchar *text, gint direction);

#endif
